// exampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "example.h"
#include "exampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExampleDlg dialog

CExampleDlg::CExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExampleDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExampleDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CExampleDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExampleDlg message handlers

BOOL CExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CExampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CExampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
/////////////////////////////////////////////////////////////////////////////
BOOL CExampleDlg::LoadxpstoimageDll()
{
	m_hinstLib = LoadLibrary("xpstoimage.dll");
	if( m_hinstLib == NULL ){ 
		return FALSE;
	}

	pMBegin = (MBegin *)GetProcAddress(m_hinstLib, "MBegin");
	if( pMBegin == NULL ){ 
		FreexpstoimageDll(); 
		return FALSE;
	}
	pMConvert = (MConvert *)GetProcAddress(m_hinstLib, "MConvert");
	if( pMConvert == NULL ){ 
		FreexpstoimageDll(); 
		return FALSE;
	}
	pMSetParam = (MSetParam *)GetProcAddress(m_hinstLib, "MSetParam");
	if( pMSetParam == NULL ){ 
		FreexpstoimageDll(); 
		return FALSE;
	}
	pMEnd = (MEnd *)GetProcAddress(m_hinstLib, "MEnd");
	if( pMEnd == NULL ){ 
		FreexpstoimageDll(); 
		return FALSE;
	}

	return TRUE;
}
/////////////////////////////////////////////////////////////////////////////
BOOL CExampleDlg::FreexpstoimageDll()
{
	if( m_hinstLib ){
        FreeLibrary(m_hinstLib);
	}
	return TRUE;
}
/////////////////////////////////////////////////////////////////////////////
void CExampleDlg::OnButton1() 
{
	if( LoadxpstoimageDll() == FALSE ){
		MessageBox("Load xpstoimage.dll failed!");
		return;
	}

	long id = pMBegin();
	if(id>0){
		long imagetype = IMAGE_FORMAT_TIF;
		long bitcount = BITCOUNT_24;
		long quality = 75;
		long rotate = 0;
		long width = 0;
		long height = 0;
		long xdpi = 150;
		long ydpi = 150;

		long compression = COMPRESSION_LZW;
		long multipage = 1;

		//Set Output image param
		pMSetParam( id,imagetype,bitcount,quality,rotate,width,height,xdpi,ydpi,compression,multipage);

		//Convert to tiff file (multiple page)
		pMConvert(id,"test.xps","","multiple");
		pMEnd(id);
	}	

	FreexpstoimageDll();
	MessageBox("Convert finished!");
}
/////////////////////////////////////////////////////////////////////////////
void CExampleDlg::OnButton2() 
{
	if( LoadxpstoimageDll() == FALSE ){
		MessageBox("Load xpstoimage.dll failed!");
		return;
	}

	long id = pMBegin();
	if(id>0){
		long imagetype = IMAGE_FORMAT_JPG;
		long bitcount = BITCOUNT_8G;//256 color grayscale( 8 bits )
		long quality = 85;
		long rotate = 90;
		long width = 1000;
		long height = 800;
		long xdpi = 200;
		long ydpi = 200;
		//only for tiff
		long compression = 0;
		long multipage = 0;

		//Set Output image param
		pMSetParam( id,imagetype,bitcount,quality,rotate,width,height,xdpi,ydpi,compression,multipage);

		//Convert to jpg file
		pMConvert(id,"test.xps","path","jpg");
		pMEnd(id);
	}

	FreexpstoimageDll();
	MessageBox("Convert finished!");
}
